diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index df5ce47a4..7fb04b990 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -5,7 +5,8 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.Blocks;
@@ -15,196 +16,184 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.PacketSignUpdate;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
 
-public class ScreenSignEditor extends Screen
-{
+public class ScreenSignEditor extends Screen {
     private boolean inKeyboard = false;
-    public ScreenSignEditor(@NotNull TileEntitySign sign)
-    {
-        screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
-        editLine = 0;
-        entitySign = sign;
+
+    public ScreenSignEditor(@NotNull TileEntitySign sign) {
+        this.screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
+        this.editLine = 0;
+        this.entitySign = sign;
     }
 
     @Override
-	public void init()
-    {
-        buttons.clear();
+    public void init() {
+        this.buttons.clear();
         Keyboard.enableRepeatEvents(true);
 
-        Block<?> block = entitySign.getBlock();
-        if(block == Blocks.SIGN_POST_PLANKS_OAK)
-        {
-            yOffset = 36;
+        Block<?> block = this.entitySign.getBlock();
+        if (block == Blocks.SIGN_POST_PLANKS_OAK) {
+            this.yOffset = 36;
         }
 
-        buttons.add(new ButtonElement(0, width / 2 - 100, 150 + 50 + yOffset, I18n.getInstance().translateKey("gui.edit_sign.button.done")));
-        
-        buttons.add(new ButtonElement(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
-        buttons.add(new ButtonElement(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
+        this.buttons.add(new ButtonElement(0, this.width / 2 - 100, 150 + 50 + this.yOffset, I18n.getInstance().translateKey("gui.edit_sign.button.done")));
+
+        this.buttons.add(new ButtonElement(1, this.width / 2 - 20, 120 + 50 + this.yOffset, 20, 20, "<"));
+        this.buttons.add(new ButtonElement(2, this.width / 2, 120 + 50 + this.yOffset, 20, 20, ">"));
 
         boolean wallSign = false;
         if (Block.hasLogicClass(block, BlockLogicSign.class)) {
             wallSign = !((BlockLogicSign) block.getLogic()).isFreeStanding;
         }
 
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 0 + 67 + (wallSign ? 31 : 0), 100, 12, "")
-            .setActionListener(() -> {editLine = 0; inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 1 + 67 + (wallSign ? 31 : 0), 100, 12, "")
-            .setActionListener(() -> {editLine = 1;inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 2 + 67 + (wallSign ? 31 : 0), 100, 12, "")
-            .setActionListener(() -> {editLine = 2;inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 3 + 67 + (wallSign ? 31 : 0), 100, 12, "")
-            .setActionListener(() -> {editLine = 3;inKeyboard = true;})).mute().hide();
-
-        inKeyboard = (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard);
+        add(new ListenerButtonElement(30, this.width / 2 - 50, 67 + (wallSign ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {
+                this.editLine = 0;
+                this.inKeyboard = true;
+            })).mute().hide();
+        add(new ListenerButtonElement(30, this.width / 2 - 50, 12 + 67 + (wallSign ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {
+                this.editLine = 1;
+                this.inKeyboard = true;
+            })).mute().hide();
+        add(new ListenerButtonElement(30, this.width / 2 - 50, 12 * 2 + 67 + (wallSign ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {
+                this.editLine = 2;
+                this.inKeyboard = true;
+            })).mute().hide();
+        add(new ListenerButtonElement(30, this.width / 2 - 50, 12 * 3 + 67 + (wallSign ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {
+                this.editLine = 3;
+                this.inKeyboard = true;
+            })).mute().hide();
+
+        this.inKeyboard = (this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard);
     }
 
     @Override
-	public void removed()
-    {
+    public void removed() {
         Keyboard.enableRepeatEvents(false);
         // I have no idea how the hell the world is null sometimes
         // but thaboard was getting a crash from the world being null
-        if(mc.currentWorld != null && mc.currentWorld.isClientSide)
-        {
-            mc.getSendQueue().addToSendQueue(new PacketSignUpdate(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
+        if (this.mc.currentWorld != null && this.mc.currentWorld.isClientSide) {
+            this.mc.getSendQueue().addToSendQueue(new PacketSignUpdate(this.entitySign.x, this.entitySign.y, this.entitySign.z, this.entitySign.signText, this.entitySign.getPicture().getId(), this.entitySign.getColor().id));
         }
     }
 
     @Override
-	public void tick()
-    {
-        updateCounter++;
+    public void tick() {
+        this.updateCounter++;
     }
 
     @Override
-	protected void buttonClicked(@NotNull ButtonElement button)
-    {
-        if(!button.enabled)
-        {
+    protected void buttonClicked(@NotNull ButtonElement button) {
+        if (!button.enabled) {
             return;
         }
-        if(button.id == 0)
-        {
-            entitySign.setChanged();
-            mc.displayScreen(null);
+        if (button.id == 0) {
+            this.entitySign.setChanged();
+            this.mc.displayScreen(null);
         }
-        if (button.id == 1)
-        {
-            int id = entitySign.getPicture().getId();
+        if (button.id == 1) {
+            int id = this.entitySign.getPicture().getId();
             int lastId = id - 1;
             if (lastId < 0) lastId = EnumSignPicture.values().length - 1;
-            entitySign.setPicture(EnumSignPicture.values()[lastId]);
-            entitySign.setChanged();
+            this.entitySign.setPicture(EnumSignPicture.values()[lastId]);
+            this.entitySign.setChanged();
         }
-        if (button.id == 2)
-        {
-            int id = entitySign.getPicture().getId();
+        if (button.id == 2) {
+            int id = this.entitySign.getPicture().getId();
             int nextId = id + 1;
             if (nextId >= EnumSignPicture.values().length) nextId = 0;
-            entitySign.setPicture(EnumSignPicture.values()[nextId]);
-            entitySign.setChanged();
+            this.entitySign.setPicture(EnumSignPicture.values()[nextId]);
+            this.entitySign.setChanged();
         }
     }
 
     @Override
-	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
-    {
-    	if(eventKey == Keyboard.KEY_ESCAPE)
-    	{
-            entitySign.setChanged();
-    		mc.displayScreen(null);
-    	}
-        if(eventKey == Keyboard.KEY_UP)
-        {
-            editLine = editLine - 1 & 3;
-        }
-        if(eventKey == Keyboard.KEY_DOWN || eventKey == Keyboard.KEY_PRINT_SCREEN || eventKey == Keyboard.KEY_NUMPADENTER)
-        {
-            editLine = editLine + 1 & 3;
-        }
-        if(eventKey == Keyboard.KEY_BACK && !entitySign.signText[editLine].isEmpty())
-        {
-            entitySign.signText[editLine] = entitySign.signText[editLine].substring(0, entitySign.signText[editLine].length() - 1);
-        }
-        if ((allowedCharacters.indexOf(eventCharacter) >= 0 || Character.isLetterOrDigit(eventCharacter)) && entitySign.signText[editLine].length() < TileEntitySign.MAX_LINE_SIZE)
-        {
-            entitySign.signText[editLine] += eventCharacter;
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            this.entitySign.setChanged();
+            this.mc.displayScreen(null);
+        }
+        if (eventKey == Keyboard.KEY_UP) {
+            this.editLine = this.editLine - 1 & 3;
+        }
+        if (eventKey == Keyboard.KEY_DOWN || eventKey == Keyboard.KEY_PRINT_SCREEN || eventKey == Keyboard.KEY_NUMPADENTER) {
+            this.editLine = this.editLine + 1 & 3;
+        }
+        if (eventKey == Keyboard.KEY_BACK && !this.entitySign.signText[this.editLine].isEmpty()) {
+            this.entitySign.signText[this.editLine] = this.entitySign.signText[this.editLine].substring(0, this.entitySign.signText[this.editLine].length() - 1);
+        }
+        if ((allowedCharacters.indexOf(eventCharacter) >= 0 || Character.isLetterOrDigit(eventCharacter)) && this.entitySign.signText[this.editLine].length() < TileEntitySign.MAX_LINE_SIZE) {
+            this.entitySign.signText[this.editLine] += eventCharacter;
         }
     }
 
     @Override
-	public void render(int mx, int my, float partialTick)
-    {
-        GL11.glColor4f(1f, 1f, 1f, 1f);
-        if (inKeyboard && (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard)) {
-            if (editLine < entitySign.signText.length) {
+    public void render(int mx, int my, float partialTick) {
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        if (this.inKeyboard && (this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard)) {
+            if (this.editLine < this.entitySign.signText.length) {
                 ScreenKeyboard keyboard = new ScreenKeyboard(this, null,
                     (s) -> {
-                        entitySign.signText[editLine] = s;
-                        if (editLine < entitySign.signText.length - 1) {
-                            editLine++;
+                        this.entitySign.signText[this.editLine] = s;
+                        if (this.editLine < this.entitySign.signText.length - 1) {
+                            this.editLine++;
                         } else {
-                            inKeyboard = false;
+                            this.inKeyboard = false;
                         }
                     },
-                    (c, k, s) -> entitySign.signText[editLine] = s,
-                    s -> entitySign.signText[editLine] = s);
-                keyboard.editor.setText(entitySign.signText[editLine]);
+                    (c, k, s) -> this.entitySign.signText[this.editLine] = s,
+                    s -> this.entitySign.signText[this.editLine] = s);
+                keyboard.editor.setText(this.entitySign.signText[this.editLine]);
                 keyboard.editor.setCursor(Integer.MAX_VALUE);
-                mc.displayScreen(keyboard);
+                this.mc.displayScreen(keyboard);
             }
         }
         renderBackground();
-        drawStringCenteredShadow(fontRenderer, screenTitle, width / 2, 40, 0xffffff);
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) width / 2, 0.0F, 50F);
+        drawStringCenteredShadow(this.fontRenderer, this.screenTitle, this.width / 2, 40, 0xffffff);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) this.width / 2, 0.0F, 50F);
         float scale = 93.75F;
-        GL11.glScalef(-scale, -scale, -scale);
-        GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-        Block<?> block = entitySign.getBlock();
+        GLRenderer.modelM4f().scale(-scale, -scale, -scale);
+        GLRenderer.modelM4f().rotateY(Math.PI_f);
+        Block<?> block = this.entitySign.getBlock();
         if (Block.hasLogicClass(block, BlockLogicSign.class)) {
             BlockLogicSign sign = (BlockLogicSign) block.getLogic();
-            if(sign.isFreeStanding)
-            {
-                float signAngle = (float)((entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
-                GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
-                GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
-            } else
-            {
-                int meta = entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE;
+            if (sign.isFreeStanding) {
+                float signAngle = (float) ((this.entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
+                GLRenderer.modelM4f().rotateY(Math.toRadians(signAngle));
+                GLRenderer.modelM4f().translate(0.0F, -1.0625F, 0.0F);
+            } else {
+                int meta = this.entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE;
                 float signAngle = 0.0F;
-                if(meta == 2)
-                {
+                if (meta == 2) {
                     signAngle = 180F;
                 }
-                if(meta == 4)
-                {
+                if (meta == 4) {
                     signAngle = 90F;
                 }
-                if(meta == 5)
-                {
+                if (meta == 5) {
                     signAngle = -90F;
                 }
-                GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
-                GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
+                GLRenderer.modelM4f().rotateY(Math.toRadians(signAngle));
+                GLRenderer.modelM4f().translate(0.0F, -1.0625F, 0.0F);
             }
         }
 
-        if((updateCounter / 6) % 2 == 0)
-        {
-            entitySign.lineBeingEdited = editLine;
+        if ((this.updateCounter / 6) % 2 == 0) {
+            this.entitySign.lineBeingEdited = this.editLine;
         }
-        GL11.glEnable(GL11.GL_BLEND);
-        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
-        entitySign.lineBeingEdited = -1;
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
-        
-        drawStringCenteredShadow(fontRenderer, I18n.getInstance().translateKey(entitySign.getPicture().getLanguageKey()), width / 2, 100 + 50 + yOffset, 0xFFFFFF);
+        GLRenderer.enableState(State.BLEND);
+        TileEntityRenderDispatcher.instance.renderTileEntity(GLRenderer.getTessellator(), this.entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
+        this.entitySign.lineBeingEdited = -1;
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.popFrame();
+
+        drawStringCenteredShadow(this.fontRenderer, I18n.getInstance().translateKey(this.entitySign.getPicture().getLanguageKey()), this.width / 2, 100 + 50 + this.yOffset, 0xFFFFFF);
 
         super.render(mx, my, partialTick);
     }
@@ -213,10 +202,10 @@ public class ScreenSignEditor extends Screen
     public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         super.guiSpecificControllerInput(controller);
         if (controller.digitalPad.up.pressedThisFrame()) {
-            editLine = editLine - 1 & 3;
+            this.editLine = this.editLine - 1 & 3;
         }
         if (controller.digitalPad.down.pressedThisFrame()) {
-            editLine = editLine + 1 & 3;
+            this.editLine = this.editLine + 1 & 3;
         }
     }
 
@@ -227,8 +216,7 @@ public class ScreenSignEditor extends Screen
     private int yOffset = 0;
     private static final String allowedCharacters;
 
-    static 
-    {
+    static {
         allowedCharacters = ChatAllowedCharacters.ALLOWED_CHARACTERS;
     }
 }
